// Klasa za liste geometrijskih figura (Lista).

#ifndef _lista2_h_
#define _lista2_h_

#include "zbirka.h"

class Lista: public Zbirka {
  friend class LIter;                        // Iterator za liste.
  struct Elem {                              // Element liste:
    Figura* fig;                             //   - figura u elementu
    Elem* sled;                              //   - slede?i element
    Elem(Figura* f, Elem* s=nullptr)         //   - konstruktor elementa
      { fig = f; sled = s; }
  };
  Elem *prvi, *posl;                         // Prvi i poslednji element.
  int  duz;                                  // Broj elemenata liste.
  void kopiraj(const Zbirka& z);             // Kopiranje u listu.
  void premesti(Zbirka& z) {                 // Premetanje u listu.
    Lista& lst = dynamic_cast<Lista&>(z);
    prvi = lst.prvi; posl = lst.posl; duz = lst.duz;
    lst.prvi = lst.posl = nullptr;
  }
  void brisi();                              // Osloba?anje memorije.
public:
  Lista() { prvi = posl = nullptr; duz = 0; }// Konstruktor prazne liste.
  int vel() const { return duz; }            // Broj elemenata liste.
  Lista& operator+=(Figura* fig) {           // Dodavanje figure.
    posl = (!prvi ? prvi : posl->sled) = new Elem(fig);
    duz++;
    return *this;
  }
  Figura*& operator[](int ind);              // Dohvatanje figure.
  using Zbirka::operator[];
  Lista& operator~()                         // Pranjenje liste.
    { brisi(); return *this;}
  Lista* kopija() const                      // Stvaranje kopije liste.
    { return new Lista(*this); }
  Iter* iter();                              // Stvaranje iteratora.
  const Iter* iter() const;
};

#endif

