// Definicija klase iteratora za nizove (N_iter).

#ifndef _niter_h_
#define _niter_h_

#include "iter.h"
#include "niz3.h"

class N_iter: public Iter {
  Niz* niz;                                    // Pokazivac na niz.
  mutable int tek;                             // Indeks tekuceg elementa.
public:
  N_iter(const Niz* n)                         // Stvaranje iteratora.
    { niz = const_cast<Niz*>(n); tek = 0;}
  bool ima() const                             // Ima li jos elemenata?
    { return tek >= 0 && tek < niz->duz; }
  N_iter& poc()                                // Pomeranje na pocetak.
    { tek = 0; return *this; }
  N_iter& operator++() {                       // Pomeranje korak napred.
    if (!ima()) Zbirka::greska(Zbirka::G_TEK);
    tek++;
    return *this;
  }
  Figura* operator->() {                       // Pokazivac na figuru.
    if (!ima()) Zbirka::greska(Zbirka::G_TEK);
    return niz->niz[tek];
  }
  using Iter::operator->;
  N_iter& operator+=(Figura* fig);             // Umetanje figure.
  N_iter& operator-=(Figura*& fig);            // Vaenje figure.
};

#endif
