// Definicija klase vektora realnih brojeva (Vekt).

class Vekt {                             // Polja:
  int min, max;                          // - granice indeksa,
  int duz;                               // - broj elemenata,
  double* niz;                           // - niz elemenata.
                                         // Pomocne metode:
  void pravi(int poc, int kra);          // - stvaranje vektora,
  void kopiraj(const Vekt& v);           // - kopiranje u vektor,
  void premesti(Vekt& v);                // - premestanje u vektor,
  void brisi();                          // - oslobadjanje memorije.

public:                                  // Kodovi gresaka:
  enum Greska { OPSEG,                   // - neispravan opseg indeksa,
                PRAZAN,                  // - vektor je prazan,
                INDEKS,                  // - indeks je izvan opsega,
                DUZINA };                // - neusaglasene duzine vektora.
                                         // Konstruktori:
  Vekt() { niz = nullptr; }              // - prazan niz,
  explicit Vekt(int kra) {pravi(1,kra);} // - podrazumevan pocetni indeks,
  Vekt(int poc, int kra){pravi(poc,kra);}// - sa zadatim indeksima,
  Vekt(const Vekt& v) { kopiraj(v); }    // - kopirajuci,
  Vekt(Vekt&& v) { premesti(v); }        // - premestajuci,
  ~Vekt() { brisi(); }                   // Destruktor.
  Vekt& operator=(const Vekt& v);        // Dodela vrednosti.
  Vekt& operator=(Vekt&& v);
  double& operator[](int ind);           // Pristup elementu.
  const double& operator[](int ind) const;
  friend double operator*(const Vekt& v, // Skalarni proizvod.
                          const Vekt& w);
  int min_ind() const { return min; }    // Najmanji indeks.
  int max_ind() const { return max; }    // Najveci indeks.
};

